import { useState } from 'react';
const shallowEqual = require('shallowequal');
export function useCollector(monitor, collect) {
    const [collected, setCollected] = useState(() => collect(monitor));
    const updateCollected = () => {
        const nextValue = collect(monitor);
        if (!shallowEqual(collected, nextValue)) {
            setCollected(nextValue);
        }
    };
    return [collected, updateCollected];
}
